/*Forest nothing
**Made by Hagrit
**Just made for fun
*/
void main(void)
{
	///INITIALIZE MAP
	rmSetStatusText("",0.01);
	
	int mapSizeMultiplier = 1;
	
	int playerTiles = 7500;
	if(cMapSize == 1)
	{
		playerTiles = 9750;
		mapSizeMultiplier = 1;
	}
	if (cMapSize == 2)
	{
		playerTiles = 16000;
		mapSizeMultiplier = 2;
	}
	int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles/0.9);
	rmEchoInfo("Map size="+size+"m x "+size+"m");
	rmSetMapSize(size, size);
	
	// If we have water
	rmSetSeaLevel(0.0);
	
	bool Desert	   	 = false;
	bool Grass		 = false;
	bool Snow		 = false;
	bool Erebus		 = false;
	bool Marsh		 = false;
	bool Tundra		 = false;
	
	int Style = rmRandInt(0,5);
	switch (Style)
	{
		case 0: Desert 	= true;
		case 1: Grass 	= true;
		case 2: Snow  	= true;
		case 3: Erebus	= true;
		case 4: Marsh	= true;
		case 5: Tundra	= true;
	}
	
	if (Desert)
	{
		rmTerrainInitialize("SandA");
		rmSetLightingSet("dusk");
	}
	else if (Grass)
	{
		rmTerrainInitialize("grassA");
		rmSetLightingSet("alfheim");
	}
	else if (Snow)
	{
		rmTerrainInitialize("SnowB");
		rmSetLightingSet("ghost lake");
	}
	else if (Erebus)
	{
		rmTerrainInitialize("hadesbuildable1");
		rmSetLightingSet("erebus");
	}
	else if (Marsh)
	{
		rmTerrainInitialize("MarshC");
		rmSetLightingSet("default");
	}
	else if (Tundra)
	{
		rmTerrainInitialize("TundragrassA");
		rmSetLightingSet("default");
	}
	
	rmSetGaiaCiv(cCivZeus);
	
	
	///CLASSES
	int classStartingTC	= rmDefineClass("starting tc");
	
	rmSetStatusText("",0.10);
	
	///CONSTRAINTS
	int AvoidTCSmall	= rmCreateTypeDistanceConstraint("TD0", "settlement level 1", 5);
	int AvoidSettlement	= rmCreateTypeDistanceConstraint("TD1", "settlement", 4);
	int AvoidGoat		= rmCreateTypeDistanceConstraint("TD2", "food", 4);
	int AvoidGold		= rmCreateTypeDistanceConstraint("TD3", "gold", 4);
	int AvoidAll		= rmCreateTypeDistanceConstraint("TD4", "all", 5);
	int AvoidRelic		= rmCreateTypeDistanceConstraint("TD5", "relic", 50);
	int AvoidRelicShort	= rmCreateTypeDistanceConstraint("TD6", "relic", 4);
	
	rmSetStatusText("",0.20);
	///OBJECT DEFINITION
	int IDStartingSettle		= rmCreateObjectDef("starting tc");
	rmAddObjectDefItem			(IDStartingSettle, "settlement level 1", 1, 0);
	rmSetObjectDefMinDistance	(IDStartingSettle, 0);
	rmSetObjectDefMaxDistance	(IDStartingSettle, 0);
	rmAddObjectDefToClass		(IDStartingSettle, classStartingTC);
	
	int IDStartingGoat			= rmCreateObjectDef("starting herd");
	rmAddObjectDefItem			(IDStartingGoat, "goat", rmRandInt(2,4), 3);
	rmSetObjectDefMinDistance	(IDStartingGoat, 5);
	rmSetObjectDefMaxDistance	(IDStartingGoat, 8);
	rmAddObjectDefConstraint	(IDStartingGoat, AvoidAll);
	
	int IDStartingGold			= rmCreateObjectDef("starting gold");
	rmAddObjectDefItem			(IDStartingGold, "gold mine tiny", 1, 0);
	rmSetObjectDefMinDistance	(IDStartingGold, 10);
	rmSetObjectDefMaxDistance	(IDStartingGold, 10);
	rmAddObjectDefConstraint	(IDStartingGold, AvoidAll);
	
	int IDStartingFood			= rmCreateObjectDef("starting food");
	rmAddObjectDefItem			(IDStartingFood, "berry bush", rmRandInt(5,9), 3);
	rmSetObjectDefMinDistance	(IDStartingFood, 9);
	rmSetObjectDefMaxDistance	(IDStartingFood, 9);
	rmAddObjectDefConstraint	(IDStartingFood, AvoidAll);
	
	int IDMediumBoar			= rmCreateObjectDef("medium boar");
	
	if (Desert)
		rmAddObjectDefItem			(IDMediumBoar, "Giraffe", rmRandInt(3,5), 4);
	else if (Snow)
		rmAddObjectDefItem			(IDMediumBoar, "Aurochs", rmRandInt(2,4), 4);
	else if (Tundra)
		rmAddObjectDefItem			(IDMediumBoar, "Elk", rmRandInt(5,9), 4);
	else
		rmAddObjectDefItem			(IDMediumBoar, "Boar", rmRandInt(3,5), 4);
	
	rmSetObjectDefMinDistance	(IDMediumBoar, 22);
	rmSetObjectDefMaxDistance	(IDMediumBoar, 22);
	rmAddObjectDefConstraint	(IDMediumBoar, AvoidAll);
	
	int IDMediumGold			= rmCreateObjectDef("medium gold");
	rmAddObjectDefItem			(IDMediumGold, "gold mine", 1, 0);
	rmSetObjectDefMinDistance	(IDMediumGold, 40);
	rmSetObjectDefMaxDistance	(IDMediumGold, 40);
	rmAddObjectDefConstraint	(IDMediumGold, AvoidAll);
	
	int IDFarGold				= rmCreateObjectDef("far gold");
	rmAddObjectDefItem			(IDFarGold, "gold mine", 1, 0);
	rmSetObjectDefMinDistance	(IDFarGold, 60);
	rmSetObjectDefMaxDistance	(IDFarGold, 60);
	rmAddObjectDefConstraint	(IDFarGold, AvoidAll);
	
	int IDFarHunt				= rmCreateObjectDef("far hunt");
	
	if (Desert)
		rmAddObjectDefItem		(IDFarHunt, "Elephant", rmRandInt(2,4), 5);
	else if (Marsh)
		rmAddObjectDefItem		(IDFarHunt, "Water Buffalo", rmRandInt(4,6), 5);
	else if (Snow)
		rmAddObjectDefItem		(IDFarHunt, "Aurochs", rmRandInt(4,6), 5);
	else if (Tundra)
		rmAddObjectDefItem		(IDFarHunt, "Caribou", rmRandInt(9,15), 5);
	else
		rmAddObjectDefItem		(IDFarHunt, "Boar", rmRandInt(4,6), 5);

	rmSetObjectDefMinDistance	(IDFarHunt, 65);
	rmSetObjectDefMaxDistance	(IDFarHunt, 80);
	rmAddObjectDefConstraint	(IDFarHunt, AvoidAll);
	
	int IDFarHunt2				= rmCreateObjectDef("far hunt2");
	
	if (Desert)
		rmAddObjectDefItem		(IDFarHunt2, "Elephant", rmRandInt(2,4), 5);
	else if (Marsh)
		rmAddObjectDefItem		(IDFarHunt2, "Water Buffalo", rmRandInt(4,6), 5);
	else if (Snow)
		rmAddObjectDefItem		(IDFarHunt2, "Aurochs", rmRandInt(4,6), 5);
	else if (Tundra)
		rmAddObjectDefItem		(IDFarHunt2, "Caribou", rmRandInt(9,15), 5);
	else
		rmAddObjectDefItem		(IDFarHunt2, "Boar", rmRandInt(4,6), 5);

	rmSetObjectDefMinDistance	(IDFarHunt2, 90);
	rmSetObjectDefMaxDistance	(IDFarHunt2, 120);
	rmAddObjectDefConstraint	(IDFarHunt2, AvoidAll);
	
	int IDRelic					= rmCreateObjectDef("relic");
	rmAddObjectDefItem			(IDRelic, "relic", 1, 0);
	rmSetObjectDefMinDistance	(IDRelic, 40);
	rmSetObjectDefMaxDistance	(IDRelic, 150);
	rmAddObjectDefConstraint	(IDRelic, AvoidAll);
	rmAddObjectDefConstraint	(IDRelic, AvoidRelic);
	
	int IDBird					= rmCreateObjectDef("bird");
	
	if (Desert)
		rmAddObjectDefItem		(IDBird, "vulture", 1, 0);
	else if (Erebus)
		rmAddObjectDefItem		(IDBird, "harpy", 1, 0);
	else
		rmAddObjectDefItem		(IDBird, "Hawk", 1, 0);
	
	rmSetObjectDefMinDistance	(IDBird, 0);
	rmSetObjectDefMaxDistance	(IDBird, rmXFractionToMeters(0.5));
	
	rmSetStatusText("",0.40);
	///DEFINE PLAYER LOCATIONS
	rmPlacePlayersCircular(0.3, 0.4, 0.1);
	 
	rmSetStatusText("",0.50);
	///AREA DEFINITION
	
	///SETTLEMENTS
	rmPlaceObjectDefPerPlayer(IDStartingSettle, true);
	
	int AreaPlayer = rmAddFairLoc("Settlement", false, true,  50, 80, 50, 20);
	
	AreaPlayer = rmAddFairLoc("Settlement", true, false,  55, 85, 70, 40);

	if(rmPlaceFairLocs())
	{
		AreaPlayer = rmCreateObjectDef("far settlement2");
		rmAddObjectDefItem(AreaPlayer, "Settlement", 1, 0.0);
		for(i = 1; <cNumberPlayers)
		{
			for(j = 0; <rmGetNumberFairLocs(i))
				rmPlaceObjectDefAtLoc(AreaPlayer, i, rmFairLocXFraction(i, j), rmFairLocZFraction(i, j), 1);
		}
	}
	
	rmSetStatusText("",0.70);
	///PLACE OBJECTS
	rmPlaceObjectDefPerPlayer(IDStartingGoat, true);
	rmPlaceObjectDefPerPlayer(IDStartingGold, false);
	rmPlaceObjectDefPerPlayer(IDStartingFood, false);
	rmPlaceObjectDefPerPlayer(IDMediumGold, false);
	rmPlaceObjectDefPerPlayer(IDMediumBoar, false);
	rmPlaceObjectDefPerPlayer(IDFarGold, false);
	rmPlaceObjectDefPerPlayer(IDFarHunt, false);
	rmPlaceObjectDefPerPlayer(IDFarHunt2, false);
	rmPlaceObjectDefPerPlayer(IDRelic, false);
	
	
	rmPlaceObjectDefAtLoc(IDBird, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers*mapSizeMultiplier);
	rmSetStatusText("",0.80);
	///FORESTS
	for (i = 0; < 1000*mapSizeMultiplier)
	{
		int IDAreaForests		= rmCreateArea("forests"+i);
		
		if (Desert)
			rmSetAreaForestType	(IDAreaForests, "palm forest");
		else if (Grass)
			rmSetAreaForestType	(IDAreaForests, "oak forest");
		else if (Snow)
			rmSetAreaForestType	(IDAreaForests, "snow pine forest");
		else if (Erebus)
			rmSetAreaForestType	(IDAreaForests, "hades forest");
		else if (Marsh)
			rmSetAreaForestType	(IDAreaForests, "marsh forest");
		else if (Tundra)
			rmSetAreaForestType	(IDAreaForests, "tundra forest");
		
		rmSetAreaSize			(IDAreaForests, rmAreaTilesToFraction(75), rmAreaTilesToFraction(100));
		rmAddAreaConstraint		(IDAreaForests, AvoidTCSmall);
		rmAddAreaConstraint		(IDAreaForests, AvoidSettlement);
		rmAddAreaConstraint		(IDAreaForests, AvoidGoat);
		rmAddAreaConstraint		(IDAreaForests, AvoidGold);
		rmAddAreaConstraint		(IDAreaForests, AvoidRelicShort);
		
		rmBuildArea				(IDAreaForests);
	}
	
	rmSetStatusText("",1.00);
	///BEAUTIFICATION
	
	///TRIGGERS
	
	
}